/*** Generated by streamline --lines-mark 0.1.12 - DO NOT EDIT ***/

var __global = typeof global !== 'undefined' ? global : window;
function __cb(_, fn) { var ctx = __global.__context; return function(err, result) { __global.__context = ctx; if (err) return _(err); return fn(null, result); } }
function __future(fn, args, i) { var done, err, result; var cb = function(e, r) { done = true; err = e, result = r; }; args = Array.prototype.slice.call(args); args[i] = function(e, r) { cb(e, r); }; fn.apply(this, args); return function(_) { if (done) _.call(this, err, result); else cb = _.bind(this); }.bind(this); }
function __propagate(_, err) { try { _(err); } catch (ex) { __trap(ex); } }
function __trap(err) { if (err) { if (__global.__context && __global.__context.errorHandler) __global.__context.errorHandler(err); else console.error("UNCAUGHT EXCEPTION: " + err.message + "\n" + err.stack); } }
            (function(_) {
              var __then = (_ = (_ || __trap));
/*     1 */   var json = require("./");
/*     2 */   var should = require("should");
/*     3 */   var streamline = require("streamline");
/*     4 */   var flows = streamline.flows;
/*     6 */   var SERVER = require("./test_server");
/*     7 */   var SERVER_PORT = 9999;
/*     8 */   var SERVER_ADDRESS = ("http://localhost:" + SERVER_PORT);
/*    10 */   var TEST_CASES = {
/*    12 */     "Non-existent": {
/*    13 */       url: "http://i.certainly.dont.exist.example.com",
/*    14 */       err: /ENOTFOUND/
                },
/*    17 */     "Non-200": {
/*    18 */       url: "http://json.org/404",
/*    19 */       err: /404/
                },
/*    22 */     "Non-JSON": {
/*    23 */       url: "http://google.com/",
/*    24 */       err: /SyntaxError/
                },
/*    27 */     "Empty JSON": {
/*    28 */       url: SERVER_ADDRESS,
/*    29 */       exp: null
                },
/*    33 */     Twitter: {
/*    34 */       url: "https://api.twitter.com/1/statuses/show/20.json"
                },
/*    39 */     "Zoom.it": {
/*    40 */       url: "http://api.zoom.it/v1/content/h",
/*    41 */       exp: {
/*    42 */         id: "h",
/*    43 */         url: "http://upload.wikimedia.org/wikipedia/commons/3/36/SeattleI5Skyline.jpg",
/*    44 */         ready: true,
/*    45 */         failed: false,
/*    46 */         progress: 1,
/*    47 */         shareUrl: "http://zoom.it/h",
/*    48 */         embedHtml: "<script src=\"http://zoom.it/h.js?width=auto&height=400px\"></script>",
/*    49 */         dzi: {
/*    50 */           url: "http://cache.zoom.it/content/h.dzi",
/*    51 */           width: 4013,
/*    52 */           height: 2405,
/*    53 */           tileSize: 254,
/*    54 */           tileOverlap: 1,
/*    55 */           tileFormat: "jpg"
                    }
                  }
                },
/*    61 */     "Post JSON": {
/*    62 */       url: SERVER_ADDRESS,
/*    63 */       post: ["alpha","beta","gamma",{
/*    64 */         delta: "epsilon"
                  },],
/*    66 */       exp: [{
/*    67 */         delta: "epsilon"
/*    68 */       },"gamma","beta","alpha",]
                }
              };
/*    73 */   var started = 0, finished = 0;
/*    76 */   process.on("exit", function __1() {
/*    77 */     var remaining = (started - finished);
/*    78 */     remaining.should.equal(0, (remaining + " callbacks never fired!"));
              });
/*    81 */   function test(name, data, _) {
                if (!_) {
                  return __future(test, arguments, 2);
                }
              ;
                var __then = _;
/*    82 */     var act, err;
/*    84 */     started++;
                return function(__then) {
                  return function(_) {
                    try {
/*    87 */           if (data.post) {
/*    88 */             return json.post(data.url, data.post, __cb(_, function(__0, __1) {
/*    88 */               act = __1;
                          return __then();
                        }));
                      }
                       else {
/*    90 */             return json.get(data.url, __cb(_, function(__0, __2) {
/*    90 */               act = __2;
                          return __then();
                        }));
                      }
                    ;
                    } catch (e) {
                      return __propagate(_, e);
                    };
                  }(function(e, __result) {
                    try {
                      if (e) {
/*    93 */             err = e;
                      }
                       else return _(null, __result)
                    ;
                    } catch (e) {
                      return __propagate(_, e);
                    };
                    return __then();
                  });
                }(function() {
                  try {
/*    96 */         finished++;
/*    98 */         if (data.err) {
/*    99 */           should.exist(err, ("expected error, received result: " + act));
/*   100 */           err.should.match(data.err, ((("error doesn't match expected: " + err) + " vs. ") + data.err));
/*   101 */           should.not.exist(act, ("received error *and* result: " + act));
                      return _(null);
                    }
                  ;
/*   105 */         should.not.exist(err);
/*   106 */         should.be.defined(act, "received neither error not result");
/*   113 */         ((typeof act === "object")).should.be.truthy(((name + " returned content is not an object or array: ") + act));
/*   115 */         if (("exp" in data)) {
/*   117 */           should.deepEqual(act, data.exp, ((((name + " content doesn't match expected: ") + act) + " vs. ") + data.exp));
                    }
                  ;
                    return __then();
                  } catch (e) {
                    return __propagate(_, e);
                  };
                });
              };
/*   121 */   function tryTest(name, data, _) {
                if (!_) {
                  return __future(tryTest, arguments, 2);
                }
              ;
                var __then = _;
                return function(__then) {
                  return function(_) {
                    try {
/*   123 */           return test(name, data, __cb(_, function() {
/*   124 */             console.log(("	✓ " + name));
                        return __then();
                      }));
                    } catch (e) {
                      return __propagate(_, e);
                    };
                  }(function(e, __result) {
                    try {
                      if (e) {
/*   126 */             console.log(("	x " + name));
/*   127 */             console.error(("	  " + e.message));
                      }
                       else return _(null, __result)
                    ;
                    } catch (e) {
                      return __propagate(_, e);
                    };
                    return __then();
                  });
                }(function() {
                  try {
                    return __then();
                  } catch (e) {
                    return __propagate(_, e);
                  };
                });
              };
/*   132 */   console.log();
/*   133 */   return SERVER.listen(SERVER_PORT, __cb(_, function() {
/*   135 */     var testFutures = [];
/*   137 */     for (var name in TEST_CASES) {
/*   138 */       testFutures.push(tryTest(name, TEST_CASES[name]));
                };
/*   143 */     return flows.spray(testFutures).collectAll(__cb(_, function() {
/*   145 */       SERVER.close();
/*   146 */       console.log();
                  return __then();
                }));
              }));
            })();
